/*
cl /O2 /arch:AVX  /D _CRT_SECURE_NO_WARNINGS  /Oi /MD /W4 /TP /EHsc /Zi /Fa /c mpmflopsavx1.cpp
link /LARGEADDRESSAWARE mpmflopsavx1.obj CPUasm.obj asmtimeavx.obj BUFFEROVERFLOWU.LIB /OUT:MPmflopsAVX.exe
*/

 #include <stdio.h>
 #include "asmtimeavx.h"
 #include <time.h>
 
 char   heading[40]  = "64 Bit MP AVX MFLOPS Benchmark 2";

 char    timeday[30];
 void    local_time();


 int main(int argc, char *argv[])
 {
    FILE    *outfile;
    int     i, g;
    int     threads = 1;
    int     param00 = 0;
    int     param01 = 99;
    int     param02 = 0;
    int     repeats = 2500;
    int     minutes = 0;
    char    command[50];  

    for (i=1; i<9; i=i+2)
    {
       if (argc > i)
       {
          switch (toupper(argv[i][0]))
          {
                case 'R':
                if (argc > i+1)
                {
                   sscanf(argv[i+1],"%d", &param00);
                   if (param00 > 0) repeats = param00;
                   if (repeats < 100) repeats = 100;
                }
                break;

                case 'T':
                if (argc > i+1)
                {
                   sscanf(argv[i+1],"%d", &param01);
                   if (param01 > -1) threads = param01;
                   if (threads > 64) threads = 64;
                }
                break;

                case 'M':
                if (argc > i+1)
                {
                   sscanf(argv[i+1],"%d", &param02);
                   if (param02 > 0)                   
                   {
                        minutes = param02;
                   }
                }
                break;
         }
       }
    }
    
    getDetails();       
    if (param01 == 99) threads = numberCPUs;
    if (param00 == 0) repeats = repeats * numberCPUs;

    if (hasAVX == 0)
    {

        printf("\n\n");
        local_time();
        outfile = fopen("MPMflopsLog.txt","a+");
        if (outfile == NULL)
        {
            printf (" Cannot open results file \n\n");
            printf(" Press Enter\n");
            g  = getchar();
            exit (0);
        }
        for (i=0; i<10; i++)
        {
                    printf("%s\n", configdata[i]);
        }
        printf("\n");
        fprintf (outfile, "\n"); 
        fprintf (outfile, "##############################################\n\n");
        for (i=1; i<10; i++)
        {
            fprintf(outfile, "%s \n", configdata[i]);
        }
        printf("  %s, %d Threads, %s\n", heading, threads, timeday);
        fprintf(outfile, "  %s, %d Threads, %s\n", heading, threads, timeday);
        printf("  Cannot run, AVX instructions not available\n\n");
        fprintf(outfile, "  Cannot run, AVX instructions not available\n\n");
        fflush(outfile);
        fclose(outfile);
        printf("\n Press Enter\n");
        g = getchar();
        exit(0);
    }
    else
    {
        sprintf(command, "onlyAVX.exe R %d T %d M %d", repeats, threads, minutes);
        system(command);
        exit(0);
    }
 }

void local_time()
{
    time_t time_of_day;
    time_of_day = time( NULL ); 
    strcpy (timeday, ctime(&time_of_day)); // timeday = date and time
    return;
}


