
  #include <stdio.h> 
  #include <conio.h> 
  #include "asmtimeavx.h"
  #include <stdlib.h>    
  #include <windows.h>
 
  char idString1[100] = " ";
  char idString2[100] = " ";

  unsigned int eaxCode1 = 0;
  unsigned int ebxCode1 = 0;
  unsigned int ecxCode1 = 0;
  unsigned int edxCode1 = 0;

  unsigned int ext81edx = 0;

  unsigned int startCount = 0;
  unsigned int endCount = 0;
  unsigned int cycleCount = 0;


  int     hasMMX = 0;
  int     hasSSE = 0;
  int     hasSSE2 = 0;
  int     hasSSE3 = 0;
  int     has3DNow = 0;
  int     hasAVX = 0;
  int     numberCPUs = 0;
  int     intel1amd2 = 0;
  DWORD   ramsize = 0;
  DWORD   freesize = 0;
  DWORD   virtsize = 0;
  DWORD   virtfree = 0;

  char configdata[10][200];

  double secs;
  unsigned int looptime = 10;
  unsigned int millisecs;
  LARGE_INTEGER starttime;


void getDetails()
{
    int megaHz;
    int max;
    int i, j, k;
    unsigned int MM_EXTENSION   = 0x00800000;
    unsigned int SSE_EXTENSION  = 0x02000000;
    unsigned int SSE2_EXTENSION = 0x04000000;
    unsigned int SSE3_EXTENSION = 0x00000001;
    unsigned int AVX_EXTENSION  = 0x18000000;
    unsigned int _3DNOW_FEATURE = 0x80000000;
    OSVERSIONINFO vers;
    char szosBuild[20] = "";
    char cpustring[50];
    char os[50];
    char mhz[50];
    SYSTEM_INFO info;
    BOOL  OldSys;    
    MEMORYSTATUS lpBuffer;
    
   
    // **************** OS *********************

    vers.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);

    GetVersionEx(&vers);
    
    if (vers.dwPlatformId == VER_PLATFORM_WIN32s)
    {
        strcpy(os, " Windows 32s ");
    }
    else if (vers.dwPlatformId == 1) // VER_PLATFORM_WIN32_WINDOWS)
    {

          if (vers.dwMajorVersion == 4 && vers.dwMinorVersion == 0)
          {
              sprintf (os, " Windows 95 ");
              if (vers.szCSDVersion[1]=='C' || vers.szCSDVersion[1]=='B')
                 strcat(os, "OSR2 " );
                 sprintf(szosBuild, "build %d,", (DWORD)(LOWORD(vers.dwBuildNumber)));
          } 
    
          if (vers.dwMajorVersion == 4 && vers.dwMinorVersion == 10)
          {
              sprintf (os, " Windows 98 ");
              if ( vers.szCSDVersion[1] == 'A' )
                 strcat(os, "SE " );
                 sprintf(szosBuild, "build %d,", (DWORD)(LOWORD(vers.dwBuildNumber)));
          } 
    
          if (vers.dwMajorVersion == 4 && vers.dwMinorVersion == 90)
          {
              sprintf (os, " Windows ME ");
              sprintf(szosBuild, " ");
          } 
    }
    else if (vers.dwPlatformId == VER_PLATFORM_WIN32_NT)
    {
        strcpy(os, " Windows NT ");
        sprintf(szosBuild, "build %d,", vers.dwBuildNumber);

    }
    else
    {
        strcpy(os, " OS? ");
    }
    sprintf (configdata[6], " %s Version %d.%d, %s %s",
                        os, vers.dwMajorVersion,
                        vers.dwMinorVersion, szosBuild, vers.szCSDVersion);

    sprintf (configdata[5], "  "); 
    sprintf (configdata[3], "  "); 

    // **************** CPU *********************

    lpBuffer.dwLength = sizeof(MEMORYSTATUS);

    GetSystemInfo(&info);
        
    OldSys = FALSE;
    if (info.dwProcessorType == PROCESSOR_INTEL_386)
    {
        strcpy(configdata[1], "  CPU Type 80386");
        OldSys = TRUE;
    }
    if (info.dwProcessorType == PROCESSOR_INTEL_486)
    {
        strcpy(configdata[1], "  CPU Type 80486");
        OldSys = TRUE;
    }

    if (!OldSys)
    {
        getCPUstring();
        if (_strnicmp(idString1, "GenuineIntel", 12) == 0)
        {
            intel1amd2 = 1;
        }
        if (_strnicmp(idString1, "AuthenticAMD", 12) == 0) intel1amd2 = 2;
        getCPUDetails();
        numberCPUs = info.dwNumberOfProcessors;

        max = 0;
        for (i=0; i<10; i++)
        {
          calculateMHz();
          megaHz = (int)((double)cycleCount / 1000000.0 / secs + 0.5);
          if (megaHz > max) max = megaHz;
        }
        megaHz = max;
        sprintf (mhz, " %d MHz", megaHz);

        if (info.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_UNKNOWN)
            strcpy(configdata[5], "  Unknown processor architecture, ");
        if (info.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_INTEL)
            strcpy(configdata[5], "  Intel processor architecture, ");
        if (info.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_IA64)
            strcpy(configdata[5], "  IA64 processor architecture, ");
        if (info.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_AMD64)
            strcpy(configdata[5], "  AMD64 processor architecture, ");


        strcpy(configdata[2], "  ");
        j = 0;
        k = 0;
        for (i=0; i<49; i++)
        {
            if (idString2[i] == ' ')
            {
                k = k + 1;
            }
            else
            {
                i = 50;
            }
        }
        for (i=k; i<49; i++)
        {
            configdata[2][j+2] = idString2[i];
            j = j + 1;      
        }
        strcat(configdata[2], " Measured");
        strcat(configdata[2], mhz);

        if (numberCPUs == 1)
        {
            strcat(configdata[5], "1 CPU ");
        }
        else if (numberCPUs > 1)
        {
            sprintf (cpustring, "%d CPUs ", numberCPUs);
            strcat(configdata[5], cpustring);
        }


        if (edxCode1 & MM_EXTENSION)
        {
               hasMMX = 1;
               strcat(configdata[3], "Has MMX, ");
        }
        else
        {
               strcat(configdata[3], "No MMX, ");
        }
        if (edxCode1 & SSE_EXTENSION)
        {
           hasSSE = 1;
           strcat(configdata[3], "Has SSE, ");
        
        }
        else
        {
            strcat(configdata[3], "No SSE, ");
        }
        if (edxCode1 & SSE2_EXTENSION)
        {
           hasSSE2 = 1;
           strcat(configdata[3], "Has SSE2, ");
        }
        else
        {
            strcat(configdata[3], "No SSE2, ");
        }
        if (ecxCode1 & SSE3_EXTENSION)
        {
           hasSSE3 = 1;
           strcat(configdata[3], "Has SSE3, ");
        }
        else
        {
            strcat(configdata[3], "No SSE3, ");
        }
        if (ecxCode1 & AVX_EXTENSION)
        {
           hasAVX = 1;
           strcat(configdata[3], "Has AVX, ");
        }
        else
        {
            strcat(configdata[3], "No AVX, ");
        }


        if (intel1amd2 == 2)
        {
            if (ext81edx & _3DNOW_FEATURE)        
            {
               has3DNow = 1;
               strcat(configdata[3], "Has 3DNow, ");
            }
            else
            {
               strcat(configdata[3], "No 3DNow,");
            }
        }
        else
        {
           strcat(configdata[3], "No 3DNow,");
        }
        sprintf(configdata[1], "  CPU %s, ecx %8.8X, edx %8.8X, Model %8.8X",
                           idString1, ecxCode1, edxCode1, eaxCode1);
    }        

    GlobalMemoryStatus(&lpBuffer);
    ramsize =  (DWORD)((double)lpBuffer.dwTotalPhys / 1048576 + 0.9);
    freesize = (DWORD)((double)lpBuffer.dwAvailPhys / 1048576 + 0.9);
    sprintf(configdata[7], "  Memory %d MB, Free %d MB", ramsize, freesize);    
    virtsize = (DWORD)((double)lpBuffer.dwTotalVirtual / 1048576 + 0.9);
    virtfree = (DWORD)((double)lpBuffer.dwAvailVirtual / 1048576 + 0.9);
    sprintf(configdata[8], "  User Virtual Space %d MB, Free %d MB", virtsize, virtfree);    

    sprintf(configdata[0], "  CPUID and RDTSC Assembly Code");
    sprintf(configdata[4], "  Windows GetSystemInfo, GetVersionEx, GlobalMemoryStatus");
    
}

void start_time()
{
    QueryPerformanceCounter(&starttime);
}

void end_time()
{
    LARGE_INTEGER liDiff;
    LARGE_INTEGER liFreq;

    QueryPerformanceCounter(&liDiff);

    liDiff.QuadPart -= starttime.QuadPart;

    (void)QueryPerformanceFrequency(&liFreq);

    secs = (double)liDiff.QuadPart / (double) liFreq.QuadPart;
    millisecs = (int)(secs * 1000);
//    return secs;
}
